# -*- coding: utf-8 -*-
"""
Created on Mon Feb 24 16:25:04 2020

@author: dc
"""




# -*- coding: utf-8 -*-
"""
Created on Thu Feb 13 16:11:00 2020

@author: dc
"""

from gensim.models import Word2Vec
from gensim.utils import simple_preprocess
import json
import sys
import argparse
import glob
import os
from sklearn.decomposition import PCA
from matplotlib import pyplot
import numpy as np
import array as arr
import scipy.io
from numpy import load
from numpy import save



parser = argparse.ArgumentParser(description="Text File to Word2Vec Vectors")

#parser.add_argument("input", help="Path to the input text file")

parser.add_argument("-o", "--output", default="vector.json", help="Path to the output text file (default: worde2vector.json)")

args = parser.parse_args()

output_text_file = args.output

import pickle
filename=r'E:\Nikita_Bhatt_GPU\DCMH_tensorflow\trial\data\mscoco(org)\pickle\cat_img'
fp = open(filename, 'rb')
arr1=pickle.load(fp)
fp.close()

caption_file = r'E:\Nikita_Bhatt_GPU\DCMH_tensorflow\trial\data\mscoco(org)\coco\annotations\captions_train2014.json'
with open(caption_file, 'r') as f:
   caption_file= json.load(f)
   
cap=[]
for annot in caption_file['annotations']:
    caption = annot['caption']     
    image_id = annot['image_id']
    cap+=[caption]  
    
    
with open('caption_file.txt', 'w') as f:
    for item in cap:
        f.write("%s\n" % item)
   
 
class ReadTxtFiles(object):
      
    def __init__(self, dirname):
        self.dirname = dirname

    def __iter__(self):
        j=0
        
        for fname in os.listdir(self.dirname):
            
            
            for line in open(os.path.join(self.dirname, fname), errors='ignore'):
                yield simple_preprocess(line)
                j+=1
                print(j)
               
                

path_to_text_directory =r'E:\Nikita_Bhatt_GPU\DCMH_tensorflow\trial\data\mscoco(org)\caption'

line=(ReadTxtFiles(path_to_text_directory)) 
documents = list (line)
#ocuments=cap    
    
model = Word2Vec(line, size=300, window=5, min_count=100, workers=10,sg=1)
#model = Word2Vec(documents, size=5, window=5, min_count=2, workers=5,sg=1)
model.train(line , total_examples=len(documents),epochs=50)

model.wv.save_word2vec_format(output_text_file, binary=False)
    
X = model[model.wv.vocab]

f = open(output_text_file)

v = {"vectors": {}}
for line in f:
        #print(line)
        w, n = line.split(" ",1)
        v["vectors"][w] = list(map(float, n.split()))
        
#key=v['vectors'].keys()
        
#import pickle
di= v['vectors']





key=list(di.keys())
key=key[1:]


"""pca = PCA(n_components=2)
result = pca.fit_transform(X)
# create a scatter plot of the projection
pyplot.scatter(result[:, 0], result[:, 1])
words = list(model.wv.vocab)
for i, word in enumerate(words):
    pyplot.annotate(word, xy=(result[i, 0], result[i, 1]))
pyplot.show()
"""


id_image=sorted(arr1.keys())
all_cap_list=[]
for idm in id_image:
    caption_list=[]
    
    for cap in arr1[idm]['caption']:
        caption_list.append(cap)
        a=caption_list
        
    all_cap_list+=[a]


import re
def read_file(fname):
    word_cap=[]
    all_word_cap=[]
    for i in fname:
       a=re.findall(r"[\w']+", i)
       word_cap.append(a)
    all_word_cap+=[word_cap]
    return all_word_cap



word_list=[]
for i in all_cap_list:
    word_list+=read_file(i)

documents = word_list


word2count = {} 
for data in documents: 
    #words = nltk.word_tokenize(data) 
    for wordl in data:
        for i in wordl:
            #print(i)
            if i not in word2count.keys(): 
                word2count[i] = 1
            else: 
                word2count[i] += 1
            
#print(dataset)
            
import heapq 
freq_words = heapq.nlargest(2000, word2count, key=word2count.get)

freq_words=freq_words
print(freq_words)



wl=np.array(freq_words)



shape=len(wl)


for i in range(shape):
    l=len(wl[i])
    for j in range(l):
        if wl[i][j] in key:
            print("word at ", i," ", j, di[wl[i][j]]," ", wl[i][j])

Y_array=np.zeros([20000,1929,300] , dtype=np.float16)
j=0
for i in range(20000):
    j+=1
    print(j)
    for j in range(1929):
        for k in range(len(word_list[i])):
            if freq_words[j] in word_list[i][k]:
                for a in range(300):
                    Y_array[i][j][a]=di[key[j]][a]



save(r'E:\Nikita_Bhatt_GPU\DCMH_tensorflow\trial\data\mscoco(org)\pickle\SG(20000).npy', Y_array)

"""



#cosine similarity
import numpy as np
from sklearn.metrics.pairwise import cosine_similarity
 
# vectors
a = np.array(di['horse'])
b = np.array(di['house'])
p3 =np.array(di['player'])
p4 =np.array(di['baseball'])
 
 
# use library, operates on sets of vectors
aa = a.reshape(1,50)
ba = b.reshape(1,50)
p3 = p3.reshape(1,50)
p4 = p4.reshape(1,50)
c1 = cosine_similarity(aa, ba)
c2 = cosine_similarity(p3, p4)
 
print(
   "cosine_similarity between 'horse' & 'house'= ",c1[0][0],
    "\n\ncosine_simlarity between 'palyer' & 'baseball''= ",c2[0][0]
)


#euclidean distance

from scipy.spatial import distance
p1 = di['bird']
p2 = di['zebra']
p3 = di['car']
p4 = di['truck']
d1 = distance.euclidean(p1, p2)
d2 = distance.euclidean(p3, p4)
print("\nEuclidean distance between 'horse' & 'house''= ",d1)
print("\nEuclidean distance between 'player' & 'baseball''= ",d2)


"""












